<template>
  <div>
    <div class="ui one column centered grid">
      <h1
        class="twelve wide column"
        style="color: #4183c4"
      >
        Liste du jour ({{ new Date().toISOString().split('T')[0] }}) générée par {{ lotd.generatedBy.firstname && lotd.generatedBy.lastname ? lotd.generatedBy.firstname + ' ' + lotd.generatedBy.lastname : lotd.generatedBy.username }}
      </h1>

      <div class="twelve wide column"
        v-for="pavillon in pavillons"
        :key="pavillon._id"
      >
        <h2 class="ui header">{{ 'Pav. ' + pavillon.name }}</h2>

        <div v-if="patients.filter(p => p.pavillon._id === pavillon._id).length">
          <period-card
            :meal="lotd.meals.filter(m => m.period === 'LUNCH')[0]"
            :variants="lotd.menuVariants"
            :patients="patients.filter(p => p.pavillon._id === pavillon._id)"
            :pavillon="pavillon"
          ></period-card>
          <br/>

          <period-card
            :meal="lotd.meals.filter(m => m.period === 'DINNER')[0]"
            :variants="lotd.menuVariants"
            :patients="patients.filter(p => p.pavillon._id === pavillon._id)"
            :pavillon="pavillon"
          ></period-card>

          <h4>Les à-côté</h4>
          <table
            class="ui compact table"
            :class="pavillon.validated ? 'green' : 'orange'"
          >
            <thead>
              <tr>
                <th>Nom</th>
                <th>Quantité</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="sideMenu in pavillon.sideMenus"
                :key="sideMenu._id"
              >
                <td>{{ sideMenu.name }}</td>
                <td>Pour {{ patients.filter(p => p.pavillon._id === pavillon._id).length }} personnes</td>
              </tr>
            </tbody>
          </table>

          <h5>
            Total de patients: {{ patients.filter(p => p.pavillon._id === pavillon._id).length }}
          </h5>
          <button
            class="ui button positive"
            @click="validatePavillon(pavillon)"
          >
            Valider
          </button>
        </div>

        <div v-else>
          <h5>Pas de patient dans ce pavillon</h5>
        </div>
        <br/>
        <br/>

      </div>
    </div>
    <div v-else>
      <h1
        class="twelve wide column"
        style="color: #4183c4"
      >
        Il n'y a pas de repas prévu aujourd'hui, demandez aux diététiciens d'en ajouter
      </h1>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import store from '@/store/Store'
import PeriodCard from '@/components/lotd/PeriodCard'

export default {
  name: 'ListOfTheDay',
  store,
  data () {
    return {

    }
  },
  mounted () {
    store.dispatch('PavillonsStore/loadPavillon', this.authUser.pavillon)
      .then((response) => {
        store.dispatch('PatientsStore/loadPatients')
          .then((response) => {
            store.dispatch('MealsStore/loadMealsByDate')
              .then((response) => {
                if (response.length > 1) {
                  Promise.all([
                    store.dispatch('MenuVariantsStore/loadMenuVariantsOfMenu', response[0].menu._id),
                    store.dispatch('MenuVariantsStore/loadMenuVariantsOfMenu', response[1].menu._id)
                  ])
                } else {
                  this.$toastr.e('Attention ! Pas menus prévus pour aujourd\'hui !')
                }
              },
              (error) => {
                this.$toastr.e(error)
              })
          },
          (error) => {
            this.$toastr.e(error)
          })
      },
      (error) => {
        this.$toastr.e(error)
      })
  },
  methods: {
    validatePavillon (pavillon) {
      store.dispatch('PavillonsStore/setValidated', pavillon)
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading',
      authUser: 'AuthStore/authUser',
      pavillons: 'PavillonsStore/pavillons',
      patients: 'PatientsStore/patients',
      meals: 'MealsStore/meals',
      menuVariants: 'MenuVariantsStore/menuVariants',
      menus: 'MenusStore/menus'
    }),
    lotd () {
      let lotd = {}
      lotd.generatedBy = this.authUser
      lotd.pavillons = this.pavillons
      lotd.meals = this.meals
      lotd.menuVariants = this.menuVariants
      lotd.patients = this.patients

      lotd.diets = []
      lotd.patients.forEach(p => {
        p.diets.forEach(d => {
          let contains = false
          lotd.diets.forEach(ld => {
            if (ld._id === d._id) {
              contains = true
            }
          })
          if (!contains) {
            lotd.diets.push(d)
          }
        })
      })

      return lotd
      // console.log(JSON.parse(JSON.stringify(lotd)))
    }
  },
  components: {
    PeriodCard
  }
}
</script>
